import logging, sys
logging.basicConfig(level=logging.ERROR, format='%(asctime)s - %(levelname)s - %(message)s', datefmt='%d-%b-%y %H:%M:%S')

POSSIBLE_ERRORS_MESSAGES = {
    'connection_error': 'An error occurred: connection error, you can found more information about this error in the documentation.',
    'request_error': 'An error occurred: request error, you can found more information about this error in the documentation.',
    'response_error': 'An error occurred: response error, you can found more information about this error in the documentation.',
    'service_error': 'An error occurred: service error, you can found more information about this error in the documentation.',
    'request_type_error': 'An error occurred: request type error, you can found more information about this error in the documentation.',
    'service_data_error': 'An error occurred: service data error, you can found more information about this error in the documentation.',
    'validation_error': 'An error occurred: validation error, you can found more information about this error in the documentation.',
    'configuration_file': 'An error occurred: configuration file not found, you can found more information about this file in the documentation.',
    'con_error': 'An error occurred: connection error, you can found more information about this error in the documentation.'
}

class CustomException(Exception):
    def __init__(self, msg=''):
        self.msg = msg
        logging.error('An error occurred: %s', str(msg))
        sys.exit(1)

    def __str__(self):
        return self.msg

class ValidationError(CustomException):
    def __init__(self, msg=''):
        super().__init__(msg)

class ConError(CustomException):
    def __init__(self, msg=''):
        super().__init__(msg)

class RequestError(CustomException):
    def __init__(self, msg=''):
        super().__init__(msg)

class ResponseError(CustomException):
    def __init__(self, msg=''):
        super().__init__(msg)

class ServiceError(CustomException):
    def __init__(self, msg=''):
        super().__init__(msg)

class RequestTypeError(CustomException):
    def __init__(self, msg=''):
        super().__init__(msg)

class ServiceDataError(CustomException):
    def __init__(self, msg=''):
        super().__init__(msg)

def exception_handler(func):
    def inner_function(*args, **kwargs):
        try:
            return func(*args, **kwargs)
        except ValidationError as e:
            raise e
        except ConnectionError as e:
            raise e
        except RequestError as e:
            raise e
        except ResponseError as e:
            raise e
        except ServiceError as e:
            raise e
        except RequestTypeError as e:
            raise e
        except ServiceDataError as e:
            raise e
        except Exception as e:
            raise e
    return inner_function